#include <math.h>
#include <X11/Xlib.h>
#include <GL/gl.h>
#include <GL/glut.h>

void sub_v(int m, double *v1, double *v2, double *v3)
{
  int i;
  for (i=m; i>0; i--) *v3++ = *v1++ - *v2++;
}

void out_v(double *v1, double *v2, double *v3)
{
  *v3 = v1[1] * v2[2] - v1[2] * v2[1];
  v3[1] = v1[2] * *v2 - *v1 * v2[2];
  v3[2] = *v1 * v2[1] - v1[1] * *v2;
}

GLfloat *Normal(double *point)
{
  static GLfloat vec[3];
  double vec1[3], vec2[3], vec3[3];
  double norm;

  sub_v(3, point, point+3, vec1);
  sub_v(3, point+3, point+6, vec2);
  out_v(vec1, vec2, vec3);

  norm = sqrt(vec3[0]*vec3[0] + vec3[1]*vec3[1] + vec3[2]*vec3[2]);

  vec[0] = (GLfloat)(vec3[0]/norm);
  vec[1] = (GLfloat)(vec3[1]/norm);
  vec[2] = (GLfloat)(vec3[2]/norm);

  return(vec);
}

