#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <GL/gl.h>
#include <GL/glut.h>

#include "data.h"

extern int n_agents;

static GLfloat material_specular[4] = { 0.2, 0.2, 0.2, 1.0 }; /* ȿʬ */

extern struct  agent astart, *adata, *adata1;
extern struct  files *ldata, *ldata1;
extern struct  DH    *data,  *data1;
extern struct  CP    *cdata,  *cdata1;
extern struct  FP    *fdata0,  *fdata01;
extern struct  dynamic *ddata, *ddata1;
extern struct  report rstart, *rdata, *rdata1;
extern int     xs, ys, dynamics, maxface, maxlink, datalength;
extern char    buf1[1024], buf2[1024], bgcolor[128];
extern double  xoffset, yoffset, zoffset;
extern double  *readdata, *wholedata;
extern GLdouble eye[3];
extern GLdouble center[3];
extern GLdouble up[3];
extern int MainWindow, SubWindow;

extern int first_view, xroll, yroll, zroll, rollreport, loop_option;

extern void  RedispBoth(void);
extern GLfloat *Normal(double*);
extern void 	fReshape(void);


int data_now = 0, data_status = 0, data_skip = 1, eye_move = 0, rolled_flag = 0;

void roll_report (int type, int degree) {

static char types[3][2] = {"x", "y", "z"};

    for (rdata = &rstart; ; rdata = rdata->next) 
	if (!rdata->flag) break;

    if (type != rdata->type) {
	if (NULL == (rdata1 = malloc(sizeof(struct report)))) {
	    fprintf (stderr, "ERROR: Less memory.\n");
	    exit(2);
	}
	rdata1->type = type;
	rdata1->flag = 0;
	rdata1->degree = degree;
	rdata->flag = 1;
	rdata->next = rdata1;
	rdata1->prev = rdata;
    } else {
	rdata->degree = (rdata->degree + degree) % 360;
	if (rdata->degree == 0) {
	    rdata1 = rdata;
	    rdata = rdata->prev;
	    rdata->flag = 0;
	    free (rdata1);
	}
    }

    if (rollreport) 
	for (fprintf (stdout, "\n"), rdata = &rstart; ; rdata = rdata->next) {
	    if (rdata->flag == 0 && rdata->type == 3) break;
	    if (rdata->type == 3) continue;
	    fprintf (stdout, "%sroll = %d\n", 
		     types[rdata->type], rdata->degree);
	    if (!rdata->flag) break;
	}
}

void ZoomOut (void) {
    double x, y, z, r0, r, theta, phi;

    x = (double)(eye[0] - center[0]);
    y = (double)(eye[1] - center[1]);
    z = (double)(eye[2] - center[2]);

    theta = atan2(y, x);
    r0 = sqrt(y * y + x * x);
    phi = atan2(z, r0);
    r = sqrt(z * z + r0 * r0);

    r *= 5.0 / 4.0;

    r0 = r * cos (phi);
    eye[0] = (GLdouble)(r0 * cos (theta)) + center[0];
    eye[1] = (GLdouble)(r0 * sin (theta)) + center[1];
    eye[2] = (GLdouble)(r * sin (phi)) + center[2];

    fReshape();
}

void ZoomIn (void) {
    double x, y, z, r0, r, theta, phi;

    x = (double)(eye[0] - center[0]);
    y = (double)(eye[1] - center[1]);
    z = (double)(eye[2] - center[2]);

    theta = atan2(y, x);
    r0 = sqrt(y * y + x * x);
    phi = atan2(z, r0);
    r = sqrt(z * z + r0 * r0);

    r *= 4.0 / 5.0;

    r0 = r * cos (phi);
    eye[0] = (GLdouble)(r0 * cos (theta)) + center[0];
    eye[1] = (GLdouble)(r0 * sin (theta)) + center[1];
    eye[2] = (GLdouble)(r * sin (phi)) + center[2];
    fReshape();
}

void ZRoll_p (void) {
    double x, y, r, theta;
    
    x = (double)(eye[0] - center[0]);
    y = (double)(eye[1] - center[1]);

    theta = atan2(y, x);
    theta += 10.0 / 180.0 * 3.1415926535898;
    r = sqrt(y * y + x * x);
    
    eye[0] = (GLdouble)(r * cos (theta)) + center[0];
    eye[1] = (GLdouble)(r * sin (theta)) + center[1];

    fReshape();
}

void ZRoll_m (void) {
    double x, y, r, theta;
    
    x = (double)(eye[0] - center[0]);
    y = (double)(eye[1] - center[1]);

    theta = atan2(y, x);
    theta -= 10.0 / 180.0 * 3.1415926535898;
    r = sqrt(y * y + x * x);
    
    eye[0] = (GLdouble)(r * cos (theta)) + center[0];
    eye[1] = (GLdouble)(r * sin (theta)) + center[1];

    fReshape();
}

void XYRoll_p (void) {
    double x, y, z, r0, r, theta, phi;
    
    x = (double)(eye[0] - center[0]);
    y = (double)(eye[1] - center[1]);
    z = (double)(eye[2] - center[2]);

    theta = atan2(y, x);
    r0 = sqrt(y * y + x * x);
    phi = atan2(z, r0);
    r = sqrt(z * z + r0 * r0);

    phi += 10.0 / 180.0 * 3.1415926535898;

    r0 = r * cos (phi);
    eye[0] = (GLdouble)(r0 * cos (theta)) + center[0];
    eye[1] = (GLdouble)(r0 * sin (theta)) + center[1];
    eye[2] = (GLdouble)(r * sin (phi)) + center[2];
    fReshape();
}

void XYRoll_m (void) {
    double x, y, z, r0, r, theta, phi;
    
    x = (double)(eye[0] - center[0]);
    y = (double)(eye[1] - center[1]);
    z = (double)(eye[2] - center[2]);

    theta = atan2(y, x);
    r0 = sqrt(y * y + x * x);
    phi = atan2(z, r0);
    r = sqrt(z * z + r0 * r0);

    phi -= 10.0 / 180.0 * 3.1415926535898;

    r0 = r * cos (phi);
    eye[0] = (GLdouble)(r0 * cos (theta)) + center[0];
    eye[1] = (GLdouble)(r0 * sin (theta)) + center[1];
    eye[2] = (GLdouble)(r * sin (phi)) + center[2];
    fReshape();
}

void transcalc(double a, double d, double theta, double alpha)
{
  static double temp[3], x, y, z;
  static double ct, st, ca, sa;
  static int i;
    
  ct = cos(theta);
  st = sin(theta);
  ca = cos(alpha);
  sa = sin(alpha);

  for (i = 0; i < cdata->points; i++) {

    x = *((cdata->point) + i * 3);
    y = *((cdata->point) + i * 3 + 1);
    z = *((cdata->point) + i * 3 + 2);

    temp[0] = ct * x - st * ca * y + st * sa * z + a * ct;
    temp[1] = st * x + ct * ca * y - ct * sa * z + a * st;
    temp[2] =               sa * y +      ca * z + d;

    *((cdata->point) + i * 3)     = temp[0];
    *((cdata->point) + i * 3 + 1) = temp[1];
    *((cdata->point) + i * 3 + 2) = temp[2];
  }
}

void homotrans(int agents)
{
    
    int h, i, j, k, l, df, ni;
    double a, d, theta, alpha;
    struct  CP    *cdata2;
    
    adata = &astart;
    for (h = 0; h < agents; h++) {
	adata = adata->next;
	if (adata->use0link) {
	    data = &(adata->start);
	    cdata = data->calc;
	    fdata0 = data->face;
	    for (l = 0; l < data->faces; l++) {
		for (k = 0; k < fdata0->points * 3; k++) 
		    *((cdata->point) + k) = *((fdata0->point) + k);
		if (l != (data->faces -1)) {
		    cdata = cdata->next;
		    fdata0 = fdata0->next;
		}
	    }
	}
	for (i = 1; i <= adata->links; i++) {
	    
	    data  = &(adata->start);
	    for (j = 0; j < i; j++) 
		data = data->next;
	    
	    /* cdata  fdata0  */ 
	    cdata = data->calc;
	    fdata0 = data->face;
	    for (l = 0; l < data->faces; l++) {
		for (k = 0; k < fdata0->points * 3; k++) 
		    *((cdata->point) + k) = *((fdata0->point) + k);
		if (l != (data->faces -1)) {
		    cdata = cdata->next;
		    fdata0 = fdata0->next;
		}
	    }

	    /*  iܤѴԤʤ */ 
	    cdata2 = data->calc;
	    df = data->faces;
	    ni = i;
	    while (1) {
		a = data->a;
		d = data->d;
		alpha = data->alpha;
		theta = data->theta;
		cdata = cdata2;
		for (l = 0; l < df; l++) {
		    transcalc(a, d, theta, alpha);
		    if (l != (df - 1)) cdata = cdata->next;
		}
		if (data->parent == 0) break;
		if (data->parent == -1) {
		    data = data->prev;
		    ni--;
		} else {
		    k = ni - data->parent;
		    for (l = 0; l < k; l++) 
			data = data->prev;
		    ni -= k;
		}
	    }
	}
    }
}

void getdata (void) {
    
    int i;
    
    for (i = 0; i < dynamics; i++) 
	*(readdata + i) = *(wholedata + dynamics * data_now + i);
}

void animation( void )
{
  int i, j, k;

/*
  if (data_now >= (datalength - 1)) {
    glutIdleFunc( NULL ); 
  }
*/

  getdata();
/* data_status 
    0 -> stop;
    1 -> play;
    2 -> backplay;
    3 -> foreward one flame
    4 -> backward one flame
*/

  switch (data_status) {
    case 0:
      break;
    case 1:
      data_now += data_skip;
      if (data_now >= datalength - 1) {
	  if (loop_option) {
	      data_now -= (datalength - 1);
	      if (data_now < 0) data_now = 0;
	  } else {
	      data_now =  datalength - 1;
	      data_status = 0;
	  }
      }
      break;
    case 2: 
      data_now -= data_skip;
      if (data_now <= 0) {
	  if (loop_option) {
	      data_now += (datalength - 1);
	      if (data_now < 0) data_now = 0;
	  } else {
	      data_now = 0;
	      data_status = 0;
	  }
      }
      break;
    case 3:
      data_now += data_skip;
      if (data_now >= datalength - 1) {
	  data_now =  datalength - 1;
      }
      data_status = 0;
      break;
    case 4: 
      data_now -= data_skip;
      if (data_now <= 0) {
	  data_now = 0;
      }
      data_status = 0;
      break;
  }

  adata = &astart;
  for (i = 0; i <= n_agents; i++) {
    ddata = &(adata->dstart);
    for (j = 0; j < adata->dynamics; j++) {
      ddata = ddata->next;
      if (ddata->link == -1) continue;
      if (ddata->param == 4) {
	eye[ddata->link] = (GLfloat)*(readdata + (ddata->number - 1)) + center[ddata->link];
	eye_move = 1;
	fReshape();
        continue;
      }
      data = &(adata->start);
      for (k = 0; k < ddata->link; k++) 
	data = data->next;
      switch(ddata->param) {
        case  0:      
          data->alpha = *(readdata + (ddata->number - 1));
	  break;
	case  1:      
	  data->theta = *(readdata + (ddata->number - 1));
	  break;
	case  2:      
	  data->a = *(readdata + (ddata->number - 1));
	  break;
	case  3:      
	  data->d = *(readdata + (ddata->number - 1));
	  break;
	default:
	  break;
      }
    }
  if (i != n_agents)  adata = adata->next;
  }

  homotrans(n_agents);

  RedispBoth();
}

void display( void )
{
  int i, j, k, h, linkflag;
  GLfloat color[4] = {0.0, 0.0, 0.0, 1.0};

    if (first_view && !eye_move) {
	switch (first_view) {
	  case 1: 
	    for (rdata = &rstart;; rdata = rdata->next) {
		switch (rdata->type) {
		  case 0:
		    glRotatef ((GLdouble)rdata->degree, 1.0, 0.0, 0.0);
		    break;
		  case 1:
		    glRotatef ((GLdouble)rdata->degree, 0.0, 1.0, 0.0);
		    break;
		  case 2:
		    glRotatef ((GLdouble)rdata->degree, 0.0, 0.0, 1.0);
		    break;
		  default:
		    break;
		}
		if (!rdata->flag) break;
	    }
	    break;
	  case 2:
	    if (!eye_move) glRotatef ( 10.0, 1.0, 0.0, 0.0);
	    break;
	  case 3:
	    if (!eye_move) glRotatef (-10.0, 1.0, 0.0, 0.0);
	    break;
	  case 4:
	    if (!eye_move) glRotatef ( 10.0, 0.0, 1.0, 0.0);
	    break;
	  case 5:
	    if (!eye_move) glRotatef (-10.0, 0.0, 1.0, 0.0);
	    break;
	  case 6:
	    if (!eye_move) glRotatef ( 10.0, 0.0, 0.0, 1.0);
	    break;
	  case 7:
	    if (!eye_move) glRotatef (-10.0, 0.0, 0.0, 1.0);
	    break;
	}
	first_view = 0;
    } else if (eye_move) {
	for (rdata = &rstart;; rdata = rdata->next) {
	    switch (rdata->type) {
	      case 0:
		glRotatef ((GLdouble)rdata->degree, 1.0, 0.0, 0.0);
		break;
	      case 1:
		glRotatef ((GLdouble)rdata->degree, 0.0, 1.0, 0.0);
		break;
	      case 2:
		glRotatef ((GLdouble)rdata->degree, 0.0, 0.0, 1.0);
		break;
	      default:
		break;
	    }
	    if (!rdata->flag) break;
	}
    }
    rolled_flag = 1;

  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  glMaterialfv(GL_FRONT, GL_SPECULAR, material_specular);
  glMaterialf(GL_FRONT, GL_SHININESS, 10.0);

  adata = &astart;
  for (h = 0; h < n_agents; h++) {
    adata = adata->next;
    data = &(adata->start);
    for (i = linkflag = 0; i < adata->links; i++) {
      if (adata->use0link == 1 && linkflag == 0) {
	i--;
	linkflag = 1;
      } else {
	data = data->next;
      }
      cdata = data->calc;
      for (j = 0; j < data->faces; j++) {
        color[0] = (GLfloat)(cdata->color[0]);
        color[1] = (GLfloat)(cdata->color[1]);
        color[2] = (GLfloat)(cdata->color[2]);
        glMaterialfv(GL_FRONT, GL_DIFFUSE, color); 
        glBegin(GL_POLYGON);
        glNormal3fv(Normal(cdata->point));
          for ( k=0; k<cdata->points; k++ ){
            glVertex3f((GLfloat)*(cdata->point + k * 3 + 0) + (GLfloat)(adata->xc) + (GLfloat)xoffset,
		       (GLfloat)*(cdata->point + k * 3 + 1) + (GLfloat)(adata->yc) + (GLfloat)yoffset,
	               (GLfloat)*(cdata->point + k * 3 + 2) + (GLfloat)(adata->zc) + (GLfloat)zoffset);
          }
	glEnd();
	if (j != (data->faces - 1))
	  cdata = cdata->next;
      }
    }
  }
  glFlush();

  glutSwapBuffers();
}

