#include <stdio.h>

#include <GL/gl.h>
#include <GL/glut.h>

extern char bgcolor[128];
extern float *getColorRGB(char*);

void Init( void )
{
  float *color;

  /* setup lighting, etc */
  GLfloat light0_position[] = { 0.0, 0.0, 1.0, 0.0 }; /* ΰ */
  GLfloat light1_position[] = { -1.0, 1.0, 1.0, 0.0 }; /* ΰ */

  GLfloat light0_diffuse[] = { 0.8, 0.8, 0.8, 1.0 }; /* Ȼʬ */
  GLfloat light1_diffuse[] = { 0.5, 0.5, 0.5, 1.0 }; /* Ȼʬ */

  GLfloat light_specular[] = { 0.3, 0.3, 0.3, 1.0 }; /* ʬ */

  GLfloat lmodel_ambient[] = { 0.1, 0.1, 0.1, 1.0 }; /* ϸ */


  color = getColorRGB(bgcolor);
  glClearColor((GLfloat)*(color), (GLfloat)*(color + 1),
               (GLfloat)*(color + 2), (GLfloat)1.0); 

  /* No.0 */
  glLightfv(GL_LIGHT0, GL_POSITION, light0_position);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light0_diffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);

  /* No.1 */
  glLightfv(GL_LIGHT1, GL_POSITION, light1_position);
  glLightfv(GL_LIGHT1, GL_DIFFUSE, light1_diffuse);
  glLightfv(GL_LIGHT1, GL_SPECULAR, light_specular);

  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHT1);
  glDepthFunc(GL_LEQUAL);
  glEnable(GL_DEPTH_TEST);
}

