#include <GL/glut.h>

#include <stdio.h>

extern void roll_report (int, int);

extern void ZoomOut(void);
extern void ZoomIn(void);
extern void ZRoll_p(void);
extern void ZRoll_m(void);
extern void XYRoll_p(void);
extern void XYRoll_m(void);

extern void RedispBoth(void);

extern double  xoffset, yoffset, zoffset;
extern int  data_now, data_status, data_skip, datalength;
extern int MainWindow, SubWindow;  

extern int first_view, xroll, yroll, zroll, sub_option, rolled_flag;

void Key( unsigned char key, int x, int y )
{
  switch (key) {
    case 'q':
    case 27:
      exit(0);
      break;
    case 'i':
      ZoomIn();
      first_view = 1;
      break;
    case 'o':
      ZoomOut();
      first_view = 1;
      break;
    case 'f':
      ZRoll_p();
      first_view = 1;
      break;
    case 'b':
      ZRoll_m();
      first_view = 1;
      break;
    case 'p':
      XYRoll_p();
      first_view = 1;
      break;
    case 'n':
      XYRoll_m();
      first_view = 1;
      break;
    case ' ':
      data_status = 0;
      break;
    case '.':
      data_status = 1;
      break;
    case ',':
      data_status = 2;
      break;
    case '>':
      data_status = 1;
      break;
    case '<':
      data_status = 2;
      break;
    case 'K':
      data_status = 3;
      break;
    case 'k':
      data_status = 4;
      break;
    case 'a':
      data_status = 0;
      data_now = 0;
      break;
    case 'e':
      data_status = 0;
      data_now = datalength - 1;
      break;
    case 'z':
      zoffset -= 10.0;
      break;
    case 'Z':
      zoffset += 10.0;
      break;
    case 'y':
      yoffset -= 10.0;
      break;
    case 'Y':
      yoffset += 10.0;
      break;
    case 'x':
      xoffset -= 10.0;
      break;
    case 'X':
      xoffset += 10.0;
      break;
    case 'R':
      if (rolled_flag) {
	  xroll += 10.0;
	  roll_report (0, 10);
	  first_view = 2;
	  rolled_flag = 0;
      }
      break;
    case 'r':
      if (rolled_flag) {
	  xroll -= 10.0;
	  roll_report (0, -10);
	  first_view = 3;
	  rolled_flag = 0;
      }
      break;
    case 'T':
      if (rolled_flag) {
	  yroll += 10.0;
	  roll_report (1, 10);
	  first_view = 4;
	  rolled_flag = 0;
      }
      break;
    case 't':
      if (rolled_flag) {
	  yroll -= 10.0;
	  roll_report (1, -10);
	  first_view = 5;
	  rolled_flag = 0;
      }
      break;
    case 'G':
      if (rolled_flag) {
	  zroll += 10.0;
	  roll_report (2, 10);
	  first_view = 6;
	  rolled_flag = 0;
      }
      break;
    case 'g':
      if (rolled_flag) {
	  zroll -= 10.0;
	  roll_report (2, -10);
	  first_view = 7;
	  rolled_flag = 0;
      }
      break;
    case '_':
      sub_option = 1;
      break;
  }
  if (key >= '0' && key <= '9') {
    key -= '0';
    if (key == 0) key = 10;
    data_skip = key;
  }
  RedispBoth();

}

void SpecialKey( int key, int x, int y )
{
  switch (key) {
    case GLUT_KEY_UP:
      break;
    case GLUT_KEY_DOWN:
      break;
  }
  glutPostRedisplay();
}
