/*
 * Scherzo/GL (Aug. 19, 1997)
 *   fully depending on the previous work "Scherzo" by Masaaki Hara;
 *   simply exported to OpenGL API by Tasuku Hoshino.
 *
 *   requires: Mesa-2.2, glut-3.5.
 * 
 *   cf. "util/glutskel.c" in Mesa-2.2 distribution.
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <X11/Xlib.h>

#include <GL/gl.h>
#include <GL/glut.h>

extern char *readargdisplay(int*, char*[]);
extern void Read(int*, char*[]);
extern void Read2(int*, char*[]);
extern void make_roll_report (void);

extern void Init(void);
static void Reshape(int, int);
extern void Key(unsigned char, int, int);
extern void SpecialKey(int, int, int);
extern void display(void);
extern void animation(void);

extern void subInit(void);
extern void subReshape(int, int);
extern void subdisplay(void);
extern void Mouse(int, int, int, int);
extern void mainMouse(int, int, int, int);

extern void getwindowinformation (unsigned int *, unsigned int *);

extern char cdir[128];
extern int  cdirflag;

/* Υǡ */
GLdouble eye[3] = { 1200.0, 0.0, 1200.0 };
GLdouble center[3] = { 0.0, 0.0, 0.0 };

char *cfile, *dfile, *Window_Name;

int first_view, xroll, yroll, zroll;

/* dhmain.c */
#include "data.h"

#ifndef PI
#define	 PI    3.14159265358979323846264
#endif

extern int ReadDHParameter(char *, int);
extern int readagent(char *);
extern int readwholedata (int, char *);

char    buf1[1024], buf2[1024], bgcolor[128];
double  fovy;
double  xoffset, yoffset, zoffset;

struct  report  rstart, *rdata, *rdata1;
struct  agent   astart, *adata, *adata1;
struct	DH	*data,  *data1;
struct	CP	*cdata,  *cdata1;
struct	FP	*fdata0,  *fdata01;
struct	files	lstart, *ldata, *ldata1;
struct	dynamic	dstart, *ddata, *ddata1;
int	dynamics, maxlink, maxface, xs, ys, sxs, sys;
int	sub_posx, sub_posy, posflag, nomenu, rollreport, loop_option;
double	*readdata, *wholedata;

int n_agents, datalength;
int MainWindow, SubWindow;

Display *disp;
Colormap cm;

void SetDHParameter (int agents)
{
  int h, i, j, points;
  char localbuf[256];
  
  adata = &astart;
  for (h = 0; h < agents; h++) {

    adata = adata->next;
    data = &(adata->start);
    ldata = &(adata->lstart);
    
    for (i = 0; i < adata->links; i++) {

      ldata = ldata->next;
	if (ldata->number == 0) 
	    data1 = &(adata->start);
      else
	  if (NULL == (data1 = malloc(sizeof(struct DH)))) {
	    fprintf(stderr, "ERROR: Less memory.\n");
	    exit (2);
	  }

      if (*(ldata->name) == '/' || cdirflag == 0) {
	strcpy (localbuf, ldata->name);
      } else {
        sprintf (localbuf, "%s%s", cdir, ldata->name);
      }
 
     points = ReadDHParameter(localbuf, ldata->number);

      fdata0 = data1->face;
      for (j = 0; j < data1->faces; j++) {
	if (j == 0) {
	  if (NULL == (data1->calc = malloc(sizeof(struct CP)))) {
	    fprintf(stderr, "ERROR: Less memory.\n");
	    exit (2);
	  }
	  cdata = data1->calc;
	  cdata->points = fdata0->points;
	  if (NULL == (  cdata->point = malloc (sizeof(double) * 3 * cdata->points))) {
	    fprintf(stderr, "ERROR: Less memory.\n");
	    exit (2);
	  }
	  cdata->color[0] = fdata0->color[0];
	  cdata->color[1] = fdata0->color[1];
	  cdata->color[2] = fdata0->color[2];
	} else {
	  if (NULL == (  cdata1 = malloc(sizeof(struct CP)))) {
	    fprintf(stderr, "ERROR: Less memory.\n");
	    exit (2);
	  }
	  cdata1->points = fdata0->points;
	  if (NULL == (  cdata1->point = malloc (sizeof(double) * 3 * cdata1->points))) {
	    fprintf(stderr, "ERROR: Less memory.\n");
	    exit (2);
	  }
	  cdata1->color[0] = fdata0->color[0];
	  cdata1->color[1] = fdata0->color[1];
	  cdata1->color[2] = fdata0->color[2];
	  cdata->next = cdata1;
	  cdata1->prev = cdata;
	  cdata = cdata1;
	}
	if (j != (data1->faces - 1)) 
	    fdata0 = fdata0->next;
      }
      if (ldata->number == 0) {
	i--;
      } else {
	data->next = data1;
	data1->prev = data;
	data = data1;
      }
    }
  }
}

void GetWholeCenter (int agents) 
{
  float xcs, ycs, zcs;
  int i;
  
  xcs = ycs = zcs = 0.0;
  
  for (adata = &astart, i = 0; i < agents; i++) {
    adata = adata->next;
    xcs += (float)adata->xc;
    ycs += (float)adata->yc;
    zcs += (float)adata->zc;
  }
  center[0] = (GLfloat)xcs / (GLfloat)agents;
  center[1] = (GLfloat)ycs / (GLfloat)agents;
  center[2] = (GLfloat)zcs / (GLfloat)agents; 
}

void CreateSubWindow(void) {

    unsigned int height, width;

    getwindowinformation (&height, &width);

    glutInitWindowSize( sxs, sys );
    if (posflag) glutInitWindowPosition( sub_posx < 0 ? width + sub_posx - sxs : sub_posx, sub_posy < 0 ? height + sub_posy - sys : sub_posy);
    glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
    SubWindow = glutCreateWindow( "Scherzo Control" );
    subInit();
    glutReshapeFunc( subReshape );
    glutIdleFunc( animation );
    glutDisplayFunc( subdisplay );
    glutMouseFunc( Mouse );
    glutKeyboardFunc( Key );
}

int main( int argc, char *argv[] )
{
  
  int i;
/*
    int j;
*/

  disp = XOpenDisplay(readargdisplay(&argc, argv));
  cm = DefaultColormap(disp, 0);
  xroll = yroll = zroll = 0;
  first_view = 1;
  nomenu = rollreport = loop_option = 0;
  
  Read( &argc, argv );
  
  n_agents = readagent(cfile);
  make_roll_report();
  for (adata = &astart, i = 0; i < n_agents; i++) {
    adata = adata->next;
    maxlink += adata->use0link;
  }
  
  if (NULL == ( readdata =  malloc(sizeof(double) * dynamics))) {
    fprintf(stderr, "ERROR: Less memory.\n");
    exit (2);
  }
  datalength = readwholedata(dynamics, dfile);
  SetDHParameter(n_agents);
  GetWholeCenter(n_agents);

/*
    adata = &astart;
    for (i = 0; i < n_agents; i++) {
	adata = adata->next;
	data = &(adata->start);
	if (adata->use0link) {
	    printf ("agent %d, link %d, parent = %d\n", i, 0, data->parent);
	}
	for (j = 0; j < adata->links; j++) {
	    data = data->next;
	    printf ("agent %d, link %d, parent = %d\n", i, j + 1, data->parent);
	}
    }
*/
  glutInitWindowSize( xs, ys );
  glutInit( &argc, argv );
  glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
  
  MainWindow = glutCreateWindow( Window_Name );
  
  for (i = 0; i < 3; i++) eye[i] += center[i];
  Init();
  
  glutReshapeFunc( Reshape );
  glutMouseFunc( mainMouse );
  glutKeyboardFunc( Key );
  glutSpecialFunc( SpecialKey );
  glutDisplayFunc( display );
  glutIdleFunc( animation );

  Read2( &argc, argv );

  if (!nomenu) {
      CreateSubWindow();
  }
  glutMainLoop();
  
  return(0); /* dummy */
}

void fReshape(void)
{
  glutSetWindow(MainWindow);
  Reshape (xs, ys);
}

static void Reshape( int width, int height )
{
  int i;
  GLdouble vector[3]; /* ӥ塼åץ٥ȥ׻ѥ٥ȥ */
  GLdouble up[3]; /* ӥ塼åץ٥ȥ */
  GLdouble norm; /* ٥ȥΥΥ */
  
  glViewport( 0, 0, width, height );
  
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective((GLdouble)fovy, (GLfloat) width/(GLfloat) height, 10.0, 10000.0);
  
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  
  /* ӥ塼åץ٥ȥ׻롣*/
  for ( i=0; i<3; i++ ){
    vector[i] = center[i] - eye[i];
  }
  up[0] = - vector[0] * vector[2];
  up[1] = - vector[1] * vector[2];
  up[2] = vector[0] * vector[0] + vector[1] * vector[1];
  norm = up[0] * up[0] + up[1] * up[1] + up[2] * up[2];
  norm = sqrt ( norm );
  
  for ( i=0; i<3; ++i ) up[i] /= norm;
  
  /* ӥ塼򥻥åȤ롣*/    
  gluLookAt(eye[0], eye[1], eye[2], center[0], center[1], center[2],
	    up[0], up[1], up[2]);
  xs = width;
  ys = height;
}
