#define argIs(str) !strcmp(argv[i], str)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>

#include <X11/Xlib.h>

#include <GL/gl.h>
#include <GL/glut.h>

#include "data.h"

extern char *cfile, *dfile, *Window_Name;

extern struct  agent astart, *adata, *adata1;
extern struct  files *ldata, *ldata1;
extern struct  DH    *data,  *data1;
extern struct  CP    *cdata,  *cdata1;
extern struct  FP    *fdata0,  *fdata01;
extern struct  dynamic *ddata, *ddata1;
extern struct  report rstart, *rdata, *rdata1;
extern int     sxs, sys, xs, ys, dynamics, maxface, maxlink;
extern int     xroll, yroll, zroll, sub_posx, sub_posy, posflag;
extern char    buf1[1024], buf2[1024], bgcolor[128];
extern double  xoffset, yoffset, zoffset, fovy;
extern GLdouble center[3];
extern GLdouble eye[3];
extern Display *disp;

struct dynamic *ddata2;

int gravityflag = 0, cdirflag = 0;
char    buf3[1024], buf4[1024], fgcolor[128], cdir[128];

extern float *getColorRGB(char*);
extern double *readdata, *wholedata;
extern char    buf1[1024], dirs[128];
extern char *XSelectFile (Display *, char *, char *);
extern int nomenu, rollreport, loop_option;

void make_roll_report (void) {
    
    int i, roll = 0;

    rstart.type = 3;
    rstart.flag = 0;
    rstart.degree = 0;

    rdata = &rstart;
    for (i = 0; i < 3; i++) {
	switch (i) {
	  case 0:
	    roll = xroll;
	    break;
	  case 1:
	    roll = yroll;
	    break;
	  case 2:
	    roll = zroll;
	    break;
	  default:
	    break;
	}
	if (roll != 0) {
	    if (NULL == (rdata1 = malloc(sizeof(struct report)))) {
		fprintf (stderr, "ERROR: Less memory.\n");
		exit(2);
	    }
	    rdata1->type = i;
	    rdata1->flag = 0;
	    rdata1->degree = roll;
	    rdata->flag = 1;
	    rdata->next = rdata1;
	    rdata1->prev = rdata;
	    rdata = rdata1;
	}
    }
}

int checkspace (char *mp)
{
  int si;
  
  si = 0;
  while (1) {
    if (*(mp + si) == ' ') {
      while (1) {
	if (*(mp + si + 1) != ' ' && *(mp + si + 1) != 9) break;
	si++;
      }
      break;
    }
    if (*(mp + si) == 9) {
      while (1) {
	if (*(mp + si + 1) != ' ' && *(mp + si + 1) != 9) break;
	si++;
      }
      break;
    }
    if (*(mp + si) == 0  ) break;
    si++;
  }
  return (si);
}

FILE *opendatafile(char *filename)
{
  static FILE *fp;
  
  if (NULL == (fp = fopen (filename, "r"))) {
    fprintf (stderr, "Can not open '%s'.\n", filename);
    exit (0);
  }
  
  return (fp);
}

void readdatafile (FILE *fp)
{
  int i, j, k;
  
  while (1) {
    fgets (buf1, 1023, fp);
    if (*buf1 != '#') break;
  }
  i = k = 0;
  if (buf1[0] == ' ' || buf1[0] == 9) i = checkspace(&buf1[0]) + 1;
  while(1) {
    j = checkspace(&buf1[i]);
    *(readdata + k) = atof(&buf1[i]);
    if (k >= (dynamics - 1)) break;
    if (buf1[i + j] == 0) break;
    i += (j + 1);
    k++;
  }
}

int readwholedata (int y, char *dfile) {
  
  FILE *fp;
  int i, j, x = 0;
  
  fp = opendatafile(dfile);
  while (1) {
    fgets (buf1, 1023, fp);
    if (feof(fp)) break;
    if (*buf1 == '#') continue;
    x++;
  }
  fclose (fp);
  
  if(NULL == (wholedata = malloc(sizeof(double) * y * x))) {
    fprintf (stderr, "ERROR : Less memory.\n");
    exit (1);
  }
  
  fp = opendatafile(dfile);
  for (j = 0; j < x; j++) {
    readdatafile (fp);
    for (i = 0; i < y; i++) *(wholedata + y * j + i) = *(readdata + i);
  }
  fclose (fp);
  
  return x;
}

int includestr(char *mp, char *sp)
{
  
  int  h = 0, i = 0, j, len, lenw, flag = 0;
  
  len = strlen (sp);
  lenw = strlen (mp);    
  
  while (1) {
    j = i;
    if (*(mp + i) == *(sp + h)) {
      while (1) {
	if (*(mp + i) != *(sp + h)) break;
	i++;
	h++;
	if (h == len) {
	  flag = 1;
	  break;
	}
      }
    }
    if (flag) break;
    i = j + 1;
    h = 0;
    if (i > lenw - len) break;
  }
  return flag;
}

int includeagent(FILE *fp)
{
  
  int flag;
  
  flag = 0;
  while (1) {
    fgets (buf1, 512, fp);
    if (feof(fp)) break;
    if (includestr(buf1, "agent")) {
      flag = 1;
      break;
    }
  }
  return flag;
}


void sortlinks(int n)
{
  int i, j;
  
  if (n == 1) return;
  for (j = 0; j < (n - 1); j++) {
    ldata = &(adata1->lstart);
    for (i = 0; i < (n - 1); i++) {
      ldata=ldata->next;
      if (ldata->number > ldata->next->number) {
	ldata1 = ldata->next;
	if (i < (n - 2)) {
	  ldata->next = ldata1->next;
	  ldata->next->prev = ldata;
	}
	ldata1->prev = ldata->prev;
	ldata1->prev->next = ldata1;
	ldata1->next = ldata;
	ldata->prev = ldata1;
	ldata = ldata->prev;
      }
    }
  }
}

void sortdata(void)
{
  
  int i, j, n;
  
  n = adata1->dynamics;
  if (n == 1) return;
  for (j = 0; j < (n - 1); j++) {
    ddata = &(adata1->dstart);
    for (i = 0; i < (n - 1); i++) {
      ddata=ddata->next;
      if (ddata->number > ddata->next->number) {
	ddata1 = ddata->next;
	if (i < (n - 2)) {
	  ddata->next = ddata1->next;
	  ddata->next->prev = ddata;
	}
	ddata1->prev = ddata->prev;
	ddata1->prev->next = ddata1;
	ddata1->next = ddata;
	ddata->prev = ddata1;
	ddata = ddata->prev;
      }
    }
  }
}

int checklinks(int n)
{
  
  int i;
  char localbuf[256];
  
  sortlinks(n);
  
  ldata = &(adata1->lstart);
  if (n > 0) {
    if (ldata->next->number == 0) {
      ldata = ldata->next;
      n--;
    }
  }
  
  for (i = 0; i < n; i++) {
    ldata = ldata->next;
    if (ldata->number != (i+1)) {
      fprintf(stderr, "Error : %d or %d link.\n", i, i+1);
      exit(0);
    }
    if (*(ldata->name) == '/' || cdirflag == 0) {
      strcpy (localbuf, ldata->name);
    } else {
      sprintf (localbuf, "%s%s", cdir, ldata->name);
    }
    if (access(localbuf, F_OK) == -1) {
      fprintf(stderr, "Error : %s not found\n", ldata->name);
      exit(0);
    }
    if (access(localbuf, R_OK) == -1) {
      fprintf(stderr, "Error : %s is found but not readable\n", ldata->name);
      exit(0);
    }
  }
  return (n);
}

void checkdata(int links)
{
  int i, n;
  
  n = adata1->dynamics;
  
  sortdata();
  
  ddata = &(adata1->dstart);
  for (i = 0; i < n; i++) {
    ddata = ddata->next;
    if (ddata->link >links) {
      fprintf(stderr, "Error : data[%d] link %d does not exist.\n", ddata->number, ddata->link);
      exit(0);
    }
  }
}

void checkeyes (void) {
  struct dynamic *dp;
  int 	i;
  
  for (dp = &(astart.dstart), i = 0; i < astart.dynamics; i++) {
    dp = dp->next;
    if (dp->link < 0 || dp->link > 2) {
      fprintf(stderr, "Error : eye[%d] does not exist.\n", dp->link);
      exit (0);
    }
  }
}

int maxdynamics (struct agent *ap) {
  
  struct dynamic *dp;
  int 	i, j;
  
  for (dp = &(ap->dstart), j = i = 0; i < ap->dynamics; i++) {
    dp = dp->next;
    if (dp->number > j) j = dp->number;
  }
  return j;
}

int readconfig(char *filename, int agentflag) 
/* agent flag  1 ξ xs ys  readagent ɤߤޤ*/
{
  
  FILE	*fp;
  int 	xsflag , ysflag, xcflag, ycflag, zcflag, links, i, j;
  double	d;
  
  xsflag = ysflag = xcflag = ycflag = zcflag = links = j = 0; 
  adata1->dynamics = 0;
  
  if (NULL == (fp = fopen(filename, "r"))) {
    fprintf(stderr, "ERROR : Configuration file %s can not readalbe.\n", filename);
    exit(0);
  }
  
  ldata = &(adata1->lstart);
  ddata = &(adata1->dstart);
  
  while (!feof(fp)) {
    if (NULL == fgets(buf1, 1023, fp)) break;
    j++;
    if (*buf1 == '#') continue;
    if (includestr(buf1, "link[")) {
      if(EOF == sscanf(buf1, "link[%d] %s\n", &i, buf2)) {
	fprintf(stderr, "Error : %s in %d.\n", filename, j);
	exit(0);
      }
      if (NULL == (ldata1 = malloc(sizeof(struct files)))) {
	fprintf (stderr, "ERROR: Less memory.\n");
	exit(2);
      }
      strcpy (ldata1->name, buf2);
      ldata1->number = i;
      ldata->next = ldata1;
      ldata1->prev = ldata;
      ldata = ldata1;
      links++;
      continue;
    }
    if (includestr(buf1, "data[")) {
      if(EOF == sscanf(buf1, "data[%d] %s\n", &i, buf2)) {
	fprintf(stderr, "Error : %s in %d.\n", filename, j);
	exit(0);
      }
      if (NULL == (     ddata1 = malloc(sizeof(struct dynamic)))) {
	fprintf (stderr, "ERROR: Less memory.\n");
	exit(2);
      }
      ddata1->number = i;
      ddata1->param = -1;
      while (1) {
	if (includestr(buf2, "alpha[")) {
	  if(EOF == sscanf(buf2, "alpha[%d]", &i)) {
	    fprintf(stderr, "Error : %s in %d.\n", filename, j);
	    exit(0);
	  }
	  ddata1->param = 0; break;
	}
	if (includestr(buf2, "theta[")) {
	  if(EOF == sscanf(buf2, "theta[%d]", &i)) {
	    fprintf(stderr, "Error : %s in %d.\n", filename, j);
	    exit(0);
	  }
	  ddata1->param = 1; break;
	}
	if (includestr(buf2, "a[")) {
	  if(EOF == sscanf(buf2, "a[%d]", &i)) {
	    fprintf(stderr, "Error : %s in %d.\n", filename, j);
	    exit(0);
	  }
	  ddata1->param = 2; break;
	}
	if (includestr(buf2, "d[")) {
	  if(EOF == sscanf(buf2, "d[%d]", &i)) {
	    fprintf(stderr, "Error : %s in %d.\n", filename, j);
	    exit(0);
	  }
	  ddata1->param = 3; break;
	}
	if (includestr(buf2, "eye") && agentflag == 0) {
	  if(EOF == sscanf(buf2, "eye[%d]", &i)) {
	    fprintf(stderr, "Error : %s in %d.\n", filename, j);
	    exit(0);
	  }
	  ddata1->param = 4;
	  ddata1->link = i;
	  ddata2->next = ddata1;
	  ddata1->prev = ddata2;
	  ddata2 = ddata1;
	  astart.dynamics++;
	  break;
	}
	if (includestr(buf2, "unuse")) break;
	fprintf(stderr, "Error : %s in %d.\n", filename, j);
	exit(0);
      }
      if (ddata1->param == 4) continue;
      if (ddata1->param == -1) 
	  ddata1->link = -1;
      else
	  ddata1->link = i;
      ddata->next = ddata1;
      ddata1->prev = ddata;
      ddata = ddata1;
      adata1->dynamics++;
      continue;
    }
    sscanf(buf1, "%s %s", buf2, buf4);
    d = atof(buf4);
    i = (int)d;
    if (agentflag == 0) {
      if (!strcmp(buf2, "xscale")) {
	continue;
      }
      if (!strcmp(buf2, "yscale")) {
	continue;
      }
      if (!strcmp(buf2, "scale")) {
	fovy = d;
	continue;
      }
      if (!strcmp(buf2, "fovy")) {
	fovy = d;
	continue;
      }
      if (!strcmp(buf2, "xeye")) {
	eye[0] = (GLdouble)d;
	continue;
      }
      if (!strcmp(buf2, "yeye")) {
	eye[1] = (GLdouble)d;
	continue;
      }
      if (!strcmp(buf2, "zeye")) {
	eye[2] = (GLdouble)d;
	continue;
      }
      if (!strcmp(buf2, "xroll")) {
	xroll = (int)d;
	continue;
      }
      if (!strcmp(buf2, "yroll")) {
	yroll = (int)d;
	continue;
      }
      if (!strcmp(buf2, "zroll")) {
	zroll = (int)d;
	continue;
      }
      if (!strcmp(buf2, "xoffset")) {
	xoffset = d;
	continue;
      }
      if (!strcmp(buf2, "yoffset")) {
	yoffset = d;
	continue;
      }
      if (!strcmp(buf2, "zoffset")) {
	zoffset = d;
	continue;
      }
      if (!strcmp(buf2, "bgcolor")) {
	strcpy (bgcolor, buf4);
	continue;
      }
      if (!strcmp(buf2, "xsize")) {
	if (xsflag) {
	  fprintf(stderr, "Error : xsize redefine, %s in %d. \n", filename, j);
	  exit(0);
	}
	if ((xs = i) == 0) {
	  fprintf(stderr, "Error : xsize = 0, %s in %d. \n", filename, j);
	  exit(0);
	}
	xsflag++;
	continue;
      }
      if (!strcmp(buf2, "ysize")) {
	if (ysflag) {
	  fprintf(stderr, "Error : ysize redefine, %s in %d. \n", filename, j);
	  exit(0);
	}
	if ((ys = i) == 0) {
	  fprintf(stderr, "Error : ysize = 0, %s in %d. \n", filename, j);
	  exit(0);
	}
	ysflag++;
	continue;
      }
    }
    if (!strcmp(buf2, "xcenter")) {
      if (xcflag) {
	fprintf(stderr, "Error : xcenter redefine, %s in %d. \n", filename, j);
	exit(0);
      }
      xcflag++; adata1->xc = i;
      continue;
    }
    if (!strcmp(buf2, "ycenter")) {
      if (ycflag) {
	fprintf(stderr, "Error : ycenter redefine, %s in %d. \n", filename, j);
	exit(0);
      }
      ycflag++; adata1->yc = i;
      continue;
    }
    if (!strcmp(buf2, "zcenter")) {
      if (zcflag) {
	fprintf(stderr, "Error : ycenter redefine, %s in %d. \n", filename, j);
	exit(0);
      }
      zcflag++; adata1->zc = i;
      continue;
    }
    fprintf(stderr, "Error : %s in %d. \n", filename, j);
    exit(0);
  }
  if (agentflag == 0) {
    if (!xsflag) {
      fprintf(stderr, "Error : xsize not define in %s\n", filename);
      exit(0);
    }
    if (!ysflag) {
      fprintf(stderr, "Error : ysize not define in %s\n", filename);
      exit(0);
    }
  }
  if (!xcflag) adata1->xc = 0.0;
  if (!ycflag) adata1->yc = 0.0;
  if (!zcflag) adata1->zc = 0.0;
  if (!links) {
    fprintf(stderr, "Error : no link define in %s \n", filename);
    exit(0);
  }
  if (!adata1->dynamics) {
    fprintf(stderr, "Error : no dynamic data in %s\n", filename);
    exit(0);
  }
  fclose (fp);
  
  i = checklinks(links);
  if (i == links) {
    adata1->use0link = 0;
  } else {
    links--;
    adata1->use0link = 1;
  }
  checkdata(links);
  return(links);
}

int readagent(char *filename) {
  
  FILE *fp;
  int agents, flag, h, i, j = 0;
  int xsflag, ysflag;
  double f;
  char localbuf[256];

  maxlink = maxface = agents = xsflag = ysflag = dynamics = 0;
  fovy = 30.0;
  xoffset = yoffset = zoffset = 0.0;
  
  astart.dynamics = 0;
  
  if (NULL == (fp = fopen(filename, "r"))) {
    fprintf(stderr, "ERROR : Configuration file %s can not readalbe.\n", filename);
    exit(0);
  }
  
  flag = includeagent(fp);
  fclose (fp);
  
  if (!flag) {
    if (NULL == (adata1 = (struct agent *)malloc(sizeof(struct agent)))) {
      fprintf (stderr, "ERROR: Less memory.\n");
      exit(2);
    }
    astart.next = adata1;
    adata1->links = readconfig (filename, 0);
    maxlink += adata1->links;
    checkeyes();
    dynamics = maxdynamics(adata1) > maxdynamics(&astart) ? maxdynamics(adata1) : maxdynamics(&astart);
    return 1;
  }
  
  /*  agent б⡼ */
  
  adata = &astart;
  ddata2 = &(adata->dstart);
  fp = fopen(filename, "r");
  while (!feof(fp)) {
    if (NULL == fgets(buf1, 1023, fp)) break;
    j++;
    if (*buf1 == '#') continue;
    if (includestr(buf1, "agent")) {
      if(EOF == sscanf(buf1, "agent %s\n", buf2)) {
	fprintf(stderr, "Error : %s in %d.\n", filename, j);
	exit(0);
      }
      if (NULL == (     adata1 = malloc(sizeof(struct agent)))) {
	fprintf (stderr, "ERROR: Less memory.\n");
	exit(2);
      }
      if (*buf2 == '/' || cdirflag == 0) {
        strcpy (localbuf, buf2);
      } else {
        sprintf (localbuf, "%s%s", cdir, buf2);
      }
      adata->next = adata1;
      adata1->links = readconfig (localbuf, 1);
      maxlink += adata1->links;
      if (dynamics < (i = maxdynamics(adata1)))
	  dynamics = i;
      adata = adata1;
      agents++;
      continue;
    }
    if (includestr(buf1, "data[")) {
      if (NULL == (     ddata1 = malloc(sizeof(struct dynamic)))) {
	fprintf (stderr, "ERROR: Less memory.\n");
	exit(2);
      }
      ddata1->param = 4;
      if (includestr(buf1, "unuse")) {
	sscanf(buf1, "data[%d] unuse", &h);
	ddata1->link = -1;
      } else {
	if (!includestr(buf1, "eye[")) {
	  fprintf(stderr, "Error : %s in %d...\n", filename, j);
	  exit(0);
	}
	if (EOF == sscanf(buf1, "data[%d] eye[%d]\n", &h, &i)) {
	  fprintf(stderr, "Error : %s in %d.\n", filename, j);
	  exit(0);
	}
	ddata1->link = i;
      }
      ddata1->number = h;
      ddata2->next = ddata1;
      ddata1->prev = ddata2;
      ddata2 = ddata1;
      astart.dynamics++;
      if (dynamics < (i = maxdynamics(&astart)))
	  dynamics = i;
      continue;
    }
    sscanf(buf1, "%s %s", buf2, buf4);
    i = (int)(f = atof(buf4));
    if (!strcmp(buf2, "xsize")) {
      if (xsflag) {
	fprintf(stderr, "Error : xsize redefine, %s in %d. \n", filename, j);
	exit(0);
      }
      if ((xs = i) == 0) {
	fprintf(stderr, "Error : xsize = 0, %s in %d. \n", filename, j);
	exit(0);
      }
      xsflag++;
      continue;
    }
    if (!strcmp(buf2, "ysize")) {
      if (ysflag) {
	fprintf(stderr, "Error : ysize redefine, %s in %d. \n", filename, j);
	exit(0);
      }
      if ((ys = i) == 0) {
	fprintf(stderr, "Error : ysize = 0, %s in %d. \n", filename, j);
	exit(0);
      }
      ysflag++;
      continue;
    }
    if (!strcmp(buf2, "xscale")) {
      continue;
    }
    if (!strcmp(buf2, "yscale")) {
      continue;
    }
    if (!strcmp(buf2, "scale")) {
      fovy = f;
      continue;
    }
    if (!strcmp(buf2, "fovy")) {
      fovy = f;
      continue;
    }
    if (!strcmp(buf2, "xeye")) {
      eye[0] = (GLdouble)f;
      continue;
    }
    if (!strcmp(buf2, "yeye")) {
      eye[1] = (GLdouble)f;
      continue;
    }
    if (!strcmp(buf2, "zeye")) {
      eye[2] = (GLdouble)f;
      continue;
    }
    if (!strcmp(buf2, "xroll")) {
	xroll = (int)f;
	continue;
    }
    if (!strcmp(buf2, "yroll")) {
	yroll = (int)f;
	continue;
    }
    if (!strcmp(buf2, "zroll")) {
	zroll = (int)f;
	continue;
    }
    if (!strcmp(buf2, "xoffset")) {
      xoffset = f;
      continue;
    }
    if (!strcmp(buf2, "yoffset")) {
      yoffset = f;
      continue;
    }
    if (!strcmp(buf2, "zoffset")) {
      zoffset = f;
      continue;
    }
    if (!strcmp(buf2, "bgcolor")) {
      strcpy (bgcolor, buf4);
      continue;
    }
    fprintf(stderr, "Error : %s in %d. \n", filename, j);
    exit(0);
  }
  if (!xsflag) {
    fprintf(stderr, "Error : xsize not define in %s\n", filename);
    exit(0);
  }
  if (!ysflag) {
    fprintf(stderr, "Error : ysize not define in %s\n", filename);
    exit(0);
  }
  fclose (fp);
  checkeyes();
  return (agents);
}

int mojicheck (char *mp)
{
  int		i = 0;
  
  while (1) {
    if (*(mp + i) == '/') return (i);
    if (*(mp + i) == '+') return (i);
    if (*(mp + i) == '-') return (i);
    if (*(mp + i) == '*') return (i);
    if (*(mp + i) == ' ') return (i);
    if (*(mp + i) == 0) return (i);
    i++;
  }
  return (0);
}

double mojicalc (char *bx)
{
  double	a = 0, b;
  int		ax, si = 0, e = 0;
  
  return (atof(bx));
  
  while (1) {
    while (1) {
      ax = mojicheck (bx + si);
      if (*(bx + si) == '-') {
	if ((*(bx + si + 1) == 'P')||(*(bx + si + 1) == 'p')) {
	  a = -3.1415926535897932384626;
	  break;
	}
      } else {
	if ((*(bx + si) == 'P')||(*(bx + si) == 'p')) {
	  a = 3.1415926535897932384626;
	  break;
	}	
      }
      a = atof(bx + si);
      break;
    }
    while (1) {
      if (e == 0) {
	b = a;
	break;
      }
      if (e == 1) {
	b += a;
	break;
      }
      if (e == 2) {
	b -= a;
	break;
      }
      if (e == 3) {
	b *= a;
	break;
      }
      if (e == 4) {
	b /= a;
	break;
      }
    }
    si += ax;
    if (*(bx + si) == 0) return (b);
    switch (*(bx + si)) {
    case '+':
      e = 1;
      break;
    case '-':
      e = 2;
      break;
    case '*':
      e = 3;
      break;
    case '/':
      e = 4;
      break;
    default:
      e = 0;
      break;
    }
  }
}

int checkstart (char *mp) {
  
  int		n = 0;
  
  while (1) {
    if ((*(mp + n) != ' ') && (*(mp + n) != 0x9)) break;
    n++;
  }
  return (n);
}

int ReadDHParameter(char *filename, int linknumber) {
  
  FILE	*fp;
  int         alflag , thflag, aflag, dflag, cflag, points, faces, parent, i, j;
  double	alpha, theta, a, d, x, y, z;
  float *color;
  char 		cname[256];
  
  alpha = theta = a = d = 0.0;
  alflag = thflag = aflag = dflag = cflag = points = faces = j = 0;

  if (linknumber == 1) 
    parent = 0;
  else 
    parent = -1;
  
  fp = fopen(filename, "r");
      
  while (!feof(fp)) {
    if (NULL == (fgets(buf1, 1023, fp))) break;
    j++;
    if (*buf1 == '#') continue;
    sscanf (buf1, "%s %s", buf2, buf3);
    if (!strcmp (buf2, "point")) {
      points++;
      continue;
    }
    if (!strcmp (buf2, "alpha")) {
      if (alflag) {
	fprintf(stderr, "Error : alpha redefine, %s in %d. \n", filename, j);
	exit(0);
      }
      alflag++; alpha = mojicalc(buf3);
      continue;
    }
    if (!strcmp (buf2, "theta")) {
      if (thflag) {
	fprintf(stderr, "Error : theta redefine, %s in %d. \n", filename, j);
	exit(0);
      }
      thflag++; theta = mojicalc(buf3);
      continue;
    }
    if (!strcmp (buf2, "a")) {
      if (aflag) {
	fprintf(stderr, "Error : a redefine, %s in %d. \n", filename, j);
	exit(0);
      }
      aflag++; a = mojicalc(buf3);
      continue;
    }
    if (!strcmp (buf2, "d")) {
      if (dflag) {
	fprintf(stderr, "Error : d redefine, %s in %d. \n", filename, j);
	exit(0);
      }
      dflag++; d = mojicalc(buf3);
      continue;
    }	
    if (!strcmp (buf2, "parent")) {
      parent = (int)mojicalc(buf3);
      if (parent >= linknumber) {
	fprintf (stderr, "Error : parent number must be smaller than %d, %s in %d. \n", linknumber, filename, j);
	exit(0);
      }
      if (parent < 0) {
	fprintf (stderr, "Error : parent number must not be negative number, %s in %d. \n", filename, j);
	exit(0);
      }
      continue;
    }	
    if (!strcmp (buf2, "color")) {
      cflag = 1; strcpy (cname, buf3);
      continue;
    }
    if (!strcmp (buf2, "face")) {
      while (1) {
	if (NULL == (fgets(buf1, 1023, fp))) {
	  fprintf(stderr, "Error : endf expected. %s in %d. \n", filename, j);
	  exit(0);
	}
	j++;
	if (*buf1 == '#') continue;
	sscanf (buf1, "%s ", buf2);
	if (!strcmp (buf2, "endf")) break;
	if (EOF ==  sscanf(checkstart(buf1) + buf1, "%lf %lf %lf", &x, &y, &z)) {
	  fprintf(stderr, "Error : %s in %d. \n", filename, j);
	  exit(0);
	}
      }
      faces++;
      continue;
    }
    fprintf(stderr, "Error : %s in %d. \n", filename, j);
    exit(0);
  }
  fclose (fp);
  
  color = getColorRGB (fgcolor);

  data1->color[0] = *color;
  data1->color[1] = *(color + 1);
  data1->color[2] = *(color + 2);
  faces++;
  maxface += faces;
  data1->faces = faces;

  if (NULL == ( data1->face = malloc (sizeof(struct FP)))) {
    fprintf (stderr, "ERROR: Less memory.\n");
    exit(2);
  }

  fdata0 = data1->face;
  fdata0->points = points;
  fdata0->color[0] = data1->color[0];
  fdata0->color[1] = data1->color[1];
  fdata0->color[2] = data1->color[2];
  data1->alpha  = alpha;
  data1->theta  = theta;
  data1->a      = a;
  data1->d      = d;
  data1->parent = parent;

  if (points)
      if (NULL == (fdata0->point  = malloc (sizeof(double) * 3 * points))) {
	fprintf (stderr, "ERROR: Less memory.\n");
	exit(2);
      }

  fp = fopen(filename, "r");

  for (i = 1; i < faces; i++) {
    if (NULL == (fdata01 = malloc (sizeof(struct FP)))) {
      fprintf (stderr, "ERROR: Less memory.\n");
      exit(2);
    }
    fdata0->next = fdata01;
    fdata01->prev = fdata0;
    fdata0 = fdata01;
  }
  
  fdata0 = data1->face;
  i = 0;
  while (1) {
    fgets(buf1, 1023, fp);
    if (feof(fp)) break;
    sscanf(buf1, "%s", buf2);
    if (!strcmp(buf2, "face")) {
      j = 0;
      while (1) {
	fgets(buf1, 1023, fp);
	if (*buf1 == '#') continue;
	sscanf(buf1, "%s", buf2);
	if (!strcmp(buf2, "endf")) break;
	j++;
      }
      if (j == 0) {
	fprintf(stderr, "Error : no points face exist. in %s\n", filename);
	exit(0);
      }
      fdata0 = fdata0->next;
      fdata0->points = j;
      continue;
    }
    if (strcmp(buf2, "point")) continue;
    sscanf(buf1, "point %lf %lf %lf", &x, &y, &z);
    *(fdata0->point + i * 3)     = x;
    *(fdata0->point + i * 3 + 1) = y;
    *(fdata0->point + i * 3 + 2) = z;
    i++;
  }
  fclose (fp);
  
  fp = fopen(filename, "r");
  fdata0 = data1->face;
  i = 1;
  while (1) {
    if (faces == i) break;
    fgets(buf1, 1023, fp);
    sscanf(buf1, "%s", buf2);
    if (!strcmp (buf2, "color")) {
      sscanf(buf1, "color %s", cname);
      color = getColorRGB (cname);
      data1->color[0] = *color;
      data1->color[1] = *(color + 1);
      data1->color[2] = *(color + 2);
    }
    if (strcmp(buf2, "face")) continue;
    fdata0 = fdata0->next;
    fdata0->points++; 
    if (NULL == (   fdata0->point = malloc (sizeof(double) * 3 * fdata0->points))) {
      fprintf (stderr, "ERROR: Less memory.\n");
      exit(2);
    }
    fdata0->color[0] = data1->color[0];
    fdata0->color[1] = data1->color[1];
    fdata0->color[2] = data1->color[2];
    j = 0;
    while (1) {
      fgets(buf1, 1023, fp);
      if (*buf1 == '#') continue;
      sscanf(buf1, "%s", buf2);
      if (!strcmp(buf2, "endf")) {
	*(fdata0->point + j * 3)     = *(fdata0->point);
	*(fdata0->point + j * 3 + 1) = *(fdata0->point + 1);
	*(fdata0->point + j * 3 + 2) = *(fdata0->point + 2);
	break;
      }
      sscanf(buf1 + checkstart(buf1), "%lf %lf %lf", &x, &y, &z);
      *(fdata0->point + j * 3)     = x;
      *(fdata0->point + j * 3 + 1) = y;
      *(fdata0->point + j * 3 + 2) = z;
      j++;
    }
    i++;
  }
  fclose (fp);
  return (points);
}


int findchar (char *mp, char c) {

    int i;
    
    for (i = 0;;i++) {
	if (*(mp + i)== c) return i;
	if (*(mp + i)== 0) return 10000;
    }
    return 0;
}
	    
void checkargs (char *mp) {

    int d, p, m;
    if (!(*mp == '+' || *mp == '-')) {
	sxs = atoi(mp);
	if ((d = findchar (mp, 'x')) == 10000) return;
	mp += (d + 1);
	sys = atoi(mp);
	p = findchar(mp, '+');
	m = findchar(mp, '-');
	if (p == m) return;
	mp += (p < m) * p + (m < p) * m;
    }
    sub_posx = atoi(mp);
    p = findchar(++mp , '+');
    m = findchar(mp, '-');
    if (p == m) return;
    mp += (p < m) * p + (m < p) * m;
    sub_posy = atoi(mp);
    posflag = 1;
}

void showmessage (char *mp)
{
  fprintf(stderr, "usage: %s [Options... ] conf_file data_file\n", mp);
  fprintf(stderr, "where options are \n\n");
  fprintf(stderr, " -display <host:dpy>\t\tThe display to run on. \n");
  fprintf(stderr, " -geometry <geometry>\t\tSize and position of Main window. \n");
  fprintf(stderr, " -geometry2 <geometry>\t\tSize and position of Sub window. \n");
  fprintf(stderr, " -foreground or -fg <color>\tForeground color (default cyan). \n");
  fprintf(stderr, " -fgcolor <color>\t\tSame as -fg. \n");
  fprintf(stderr, " -background or -bg <color>\tBackground color (default black). \n");
  fprintf(stderr, " -bgcolor <color>\t\tSame as -bg. \n");
  fprintf(stderr, " -title <string>\t\tWindow title. \n");
  fprintf(stderr, " -nm \t\t\t\tNot create Sub window. \n");
  fprintf(stderr, " -nx \t\t\t\tNot create file select window if few argments. \n");
  fprintf(stderr, " -roll \t\t\t\tReport the history of rolling when object roll. \n");
  fprintf(stderr, " -loop \t\t\t\tLoop viewing.\n");
  fprintf(stderr, " -help \t\t\t\tShow this message. \n");
 
  exit(0);
}

void Read(int *argc, char *argv[])
{
    int i, n, xext[2], nx, nxx;
    char *fname[2], *stuck[2];
    
    sxs = 200;
    sys = 280;
    nxx = posflag = 0;
    Window_Name = argv[0];
    strcpy (bgcolor, "black");
    strcpy (fgcolor, "cyan");
    for ( nx=0, i=1, n=0; i<*argc; i++) {
	if (argIs("-geometry") || argIs("-display") || argIs("-title") 
	    || argIs ("-geometry2") || argIs ("-display2")  || argIs ("-help") 
	    || argIs ("-bg") || argIs ("-background") || argIs ("-bgcolor") 
	    || argIs ("-fg") || argIs ("-foreground") || argIs ("-fgcolor")
	    || argIs ("-nx") || argIs ("-nm") || argIs ("-roll")
            || argIs ("-loop")) { 
	    if (argIs("-title")) {
		Window_Name = argv[++i];
	    } else if(argIs ("-bg")||argIs("-background")||argIs ("-bgcolor")){
		strcpy (bgcolor, argv[++i]);
	    } else if(argIs ("-fg")||argIs("-foreground")||argIs ("-fgcolor")){
		strcpy (fgcolor, argv[++i]);
	    } else if(argIs ("-display") || argIs("-geometry")) {
		xext[nx++] = i++;
	    } else if(argIs("-geometry2")) {
		checkargs (argv[++i]);
	    } else if(argIs("-help")) {
		showmessage(argv[0]);
	    } else if(argIs("-nx")) {
		nxx = 1;
	    } else if(argIs("-nm")) {
		nomenu = 1;
	    } else if(argIs("-roll")) {
		rollreport = 1;
	    } else if(argIs("-loop")) {
		loop_option = 1;
	    } else {
		i++;
	    }		
	} else if (*argv[i] == '-') {
	    continue;
	} else {
	    if (n < 2) {
		fname[n++] = argv[i];
	    }
	}
    }
    
    if (n < 2) {
	if (nxx) {
	    fprintf(stderr, "usage: %s [ X options... ] conf_file data_file\n", argv[0]);
	    exit(-1);
	}
	if (n == 0) {
	    dfile = XSelectFile (disp, "Scherzo file selector", "configuration file");
	    cfile = malloc (strlen(dfile) + 1);
	    strcpy (cfile, dfile);
	    strcpy (cdir, dirs);
	    cdirflag = 1;
	} else {
	    cfile = fname[0];
	}
	dfile = XSelectFile (disp, "Scherzo file selector", "data file");
    } else {
	cfile = fname[0];
	dfile = fname[1];
    }

    for (n = 0; n < nx; n++) {
	stuck[0] = argv[xext[n]];
	stuck[1] = argv[xext[n] + 1];
	for (i = xext[n]; i >= 2; i--) 
	    argv[i + 1] = argv[i - 1];
	for (i = 1; i <= 2; i++) 
	    argv[i] = stuck[i - 1];
    }
}

char *readargdisplay(int *argc, char *argv[])
{
    int i;
    
    for ( i=1; i<*argc; i++) 
	if (argIs("-display"))
	    return argv[i + 1];
    return NULL;
}

void Read2(int *argc, char *argv[])
{
    int i, n;
    
    for ( i=1, n=0; i<*argc; i++) 
	if (argIs("-geometry") || argIs("-display")) 
	    n++;

    for (i = 1; i < (*argc - n * 2); i++) {
	argv[i] = argv[i + (n + n)];
    }
    *argc -= (n + n);
}
