#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include <X11/Xlib.h>

#include <GL/gl.h>
#include <GL/glut.h>

extern double  xoffset, yoffset, zoffset;
extern int MainWindow, SubWindow, sxs, sys;  
extern int data_now, data_status, data_skip, datalength;
extern GLdouble eye[3];

extern int first_view, xroll, yroll, zroll, nomenu, rolled_flag;

extern void CreateSubWindow (void);

extern void roll_report (int, int);

extern void ZoomOut(void);
extern void ZoomIn(void);
extern void ZRoll_p(void);
extern void ZRoll_m(void);
extern void XYRoll_p(void);
extern void XYRoll_m(void);

void paddraw(void);
void figure1(double, double);
void figure2(double, double);
void figure3(double, double);
void figure4(double, double);
void figure5(double, double);
void figure6(double, double);
void figure7(double, double);
void figure8(double, double);
void figure9(double, double);
void figure10(double, double);
void figure11(double, double);
void figure12(double, double);
void figure13(double, double);
void figure14(double, double);
void figure15(int);
void figure16(double, double);
void figure17(double, double);
void figure18(double, double);
void figure19(double, double);
void figure20(double, double);
void figure21(double, double);
void figure22(double, double);
void figure23(double, double);
void figure24(double, double);
void figure25(double, double);
void figure26(double, double);

int   mouse_status = 0;
int   sub_option = 0;

static GLfloat material_specular[4] = { 0.2, 0.2, 0.2, 1.0 }; /* ȿʬ */


void RedispBoth(void) {

  glutSetWindow(MainWindow);
  glutPostRedisplay();
  if (!nomenu) {
      glutSetWindow(SubWindow);
      glutPostRedisplay();
  }
}

void subReshape( int width, int height )
{
  GLdouble up[3], vector[3] = {0.0, 0.001, -100.0};
  GLdouble norm; 

  glViewport( 0, 0, width, height );
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective(108.0, (GLfloat) width/(GLfloat) height, 10.0, 10000.0);
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity();
  
  up[0] = - vector[0] * vector[2];
  up[1] = - vector[1] * vector[2];
  up[2] = vector[0] * vector[0] + vector[1] * vector[1];

  norm = up[0] * up[0] + up[1] * up[1] + up[2] * up[2];
  norm = sqrt ( norm );
  up[0] /= norm;  up[1] /= norm;  up[2] /= norm;

  gluLookAt(0.0, -40.001, 100.0, 0.0, -40.0, 0.0, up[0], up[1], up[2]);
  sxs = width;
  sys = height;
  glFlush();
}

void subdisplay( void )
{
  glClearColor(0.65, 0.75, 0.75, 1.0);
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, material_specular); 
  glMaterialf(GL_FRONT_AND_BACK, GL_AMBIENT, 3.0); 

  paddraw();
  glFlush();
  
  glutSwapBuffers();
}

int range (int x, int y, int x1, int y1, int x2, int y2) {
  
  if ((x > x1 && x < x2) && (y > y1 && y < y2)) 
      return 1;
  else 
      return 0;
}

void Mouse (int botton, int state, int x0, int y0) {
  
  int	x, y;
  
  if (botton == 2 && state == 0) {
    glutDestroyWindow(SubWindow);
    nomenu = 1;
    return;
  }

  if (botton == 1 && state == 0) {
      fprintf(stdout, "eye(x, y, z) = (%.2f, %.2f, %.2f)\n",
	     (float)eye[0], (float)eye[1], (float)eye[2]);
      fprintf(stdout, "roll(x, y, z) = (%d, %d, %d)\n", 
	      xroll % 360, yroll % 360, zroll % 360);
      fprintf(stdout, "offset(x, y, z) = (%.2f, %.2f, %.2f)\n", 
	      xoffset, yoffset, zoffset);
      return;
  }

  x = x0 * 200 / sxs - 100;
  y = 100 - y0 * 280 / sys;

  if (state == 0) {
    if (range(x, y, -100, 60, -70, 100)) {
      mouse_status = 1;
      xoffset -= 10.0;
    }
    if (range(x, y, -100, 20, -70, 60)) {
      mouse_status = 2;
      yoffset -= 10.0;
    }
    if (range(x, y, -100, -20, -70, 20)) {
      mouse_status = 3;
      zoffset -= 10.0;
    }
    if (range(x, y, -30, 60, -0, 100)) {
      mouse_status = 4;
      xoffset += 10.0;
    }
    if (range(x, y, -30, 20, -0, 60)) {
      mouse_status = 5;
      yoffset += 10.0;
    }
    if (range(x, y, -30, -20, -0, 20)) {
      mouse_status = 6;
      zoffset += 10.0;
    }

    if (range(x, y, 0, 60, 30, 100)) {
      mouse_status = 7;
      ZRoll_m();
      first_view = 1;
    }
    if (range(x, y, 0, 20, 30, 60)) {
      mouse_status = 8;
      XYRoll_m();
      first_view = 1;
    }
    if (range(x, y, 0, -20, 30, 20)) {
      mouse_status = 9;
      ZoomIn();
      first_view = 1;
    }
    if (range(x, y, 70, 50, 100, 100)) {
      mouse_status = 10;
      ZRoll_p();
      first_view = 1;
    }
    if (range(x, y, 70, 20, 100, 60)) {
      mouse_status = 11;
      XYRoll_p();
      first_view = 1;
    }
    if (range(x, y, 70, -20, 100, 20)) {
      mouse_status = 12;
      ZoomOut();
      first_view = 1;
    }


    if (range(x, y, -100, -60, -70, -20)) {
	mouse_status = 17;
      if (rolled_flag) {
	  rolled_flag = 0;
	  xroll -= 10;
	  roll_report (0, -10);
	  first_view = 3;
      }
    }
    if (range(x, y, -30, -60, -0, -20)) {
	mouse_status = 18;
      if (rolled_flag) {
	  xroll += 10;
	  roll_report (0, 10);
	  first_view = 2;
	  rolled_flag = 0;
      }
    }
    if (range(x, y, 0, -60, 30, -20)) {
	mouse_status = 19;
      if (rolled_flag) {
	  yroll -= 10;
	  roll_report (1, -10);
	  first_view = 5;
	  rolled_flag = 0;
      }
    }
    if (range(x, y, 70, -60, 100, -20)) {
	mouse_status = 20;
      if (rolled_flag) {
	  yroll += 10;
	  roll_report (1, 10);
	  first_view = 4;
	  rolled_flag = 0;
      }
    }
    if (range(x, y, -100, -100, -70, -60)) {
	mouse_status = 21;
      if (rolled_flag) {
	  zroll -= 10;
	  roll_report (2, -10);
	  first_view = 7;
	  rolled_flag = 0;
      }
    }
    if (range(x, y, -30, -100, -0, -60)) {
	mouse_status = 22;
      if (rolled_flag) {
	  zroll += 10;
	  roll_report (2, 10);
	  first_view = 6;
	  rolled_flag = 0;
      }
    }


    if (range(x, y, 0, -100, 100, -60)) exit(0);


    if (range(x, y, -100, -140, -60, -100)) {
      mouse_status = 13;
      data_status = 0;
      data_now = 0;
    }
    if (range(x, y, 60, -140, 100, -100)) {
      mouse_status = 14;
      data_status = 0;
      data_now = datalength - 1;
    }

    if (range(x, y, -60, -140, -20, -100)) {
      data_status = 2;
    }
    if (range(x, y, -20, -140, 20, -100)) {
      data_status = 0;
    }
    if (range(x, y, 20, -140, 60, -100)) {
      data_status = 1;
    }

    if (range(x, y, -100, -180, -60, -140)) {
      mouse_status = 15;
      if (data_skip > 1) data_skip--;
    }
    if (range(x, y, 60, -180, 100, -140)) {
      mouse_status = 16;
      if (data_skip < 10) data_skip++;
    }
  } else {
      mouse_status = 0;
  }

  RedispBoth();
}
 
void subInit( void )
{
  /* setup lighting, etc */
GLfloat light0_position[] = { 0.0, 0.0, 1.0, 0.0 }; /* ΰ */
GLfloat light0_diffuse[] = { 0.3, 0.3, 0.3, 1.0 }; /* Ȼʬ */
GLfloat light_specular[] = { 0.3, 0.3, 0.3, 1.0 }; /* ʬ */
GLfloat lmodel_ambient[] = { 0.2, 0.2, 0.2, 1.0 }; /* ϸ */

  glClearColor(0.65, 0.75, 0.75, 1.0);

  /* No.0 */
  glLightfv(GL_LIGHT0, GL_POSITION, light0_position);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light0_diffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);

  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glDepthFunc(GL_LEQUAL);
  glEnable(GL_DEPTH_TEST);
}

void statecolor (int i) {
  GLfloat color[4] = {0.0, 0.0, 0.0, 1.0};
  if (i) {
      color[0] = (GLfloat)1.0;  color[1] = (GLfloat)1.0;  color[2] = (GLfloat)1.0;
  } else {
      color[0] = (GLfloat)0.0;  color[1] = (GLfloat)0.0;  color[2] = (GLfloat)0.0;
  }
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, color);
}
  
void paddraw (void) {
  GLfloat color[4] = {0.0, 0.0, 0.0, 1.0};
  color[0] = (GLfloat)0.0;  color[1] = (GLfloat)0.0;  color[2] = (GLfloat)0.0;
  
    if (sub_option) {
	glRotatef (20.0, 0.0, 1.0, 0.0);
	sub_option = (sub_option + 1) % (18 + 1);
    }

  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, color);
  figure1 (-50.0,  80.0);
  figure2 (-50.0,  40.0);
  figure3 (-50.0,   0.0);
  figure4 ( 50.0,  80.0);
  figure5 ( 50.0,  40.0);
  figure6 ( 50.0,   0.0);

  figure18 (-50.0, -40.0);
  figure19 ( 50.0, -40.0);
  figure21 (-50.0, -80.0);
  figure26 ( 50.0, -80.0);
  
  statecolor (mouse_status == 1);
  figure10(-85.0, 80.0);
  statecolor (mouse_status == 4);
  figure11(-15.0, 80.0);

  statecolor (mouse_status == 2);
  figure10(-85.0, 40.0);
  statecolor (mouse_status == 5);
  figure11(-15.0, 40.0);

  statecolor (mouse_status == 3);
  figure10(-85.0,  0.0);
  statecolor (mouse_status == 6);
  figure11(-15.0,  0.0);

  statecolor (mouse_status == 10);
  figure11( 85.0, 80.0);
  statecolor (mouse_status == 7);
  figure10( 15.0, 80.0);

  statecolor (mouse_status == 11);
  figure11( 85.0, 40.0);
  statecolor (mouse_status == 8);
  figure10( 15.0, 40.0);

  statecolor (mouse_status == 12);
  figure11( 85.0,  0.0);
  statecolor (mouse_status == 9);
  figure10( 15.0,  0.0);


  statecolor (mouse_status == 17);
  figure10(-85.0, -40.0);
  statecolor (mouse_status == 18);
  figure11(-15.0, -40.0);

  statecolor (mouse_status == 19);
  figure10( 15.0, -40.0);
  statecolor (mouse_status == 20);
  figure11( 85.0, -40.0);

  statecolor (mouse_status == 21);
  figure10(-85.0, -80.0);
  statecolor (mouse_status == 22);
  figure11(-15.0, -80.0);


  statecolor (mouse_status == 13);
  figure13(-80.0, -120.0);
  statecolor (mouse_status == 14);
  figure14( 80.0, -120.0);

  statecolor (mouse_status == 15);
  figure7 (-80.0, -160.0);
  statecolor (mouse_status == 16);
  figure8 ( 80.0, -160.0);

  statecolor (data_status == 2);
  figure7 (-40.0, -120.0);
  statecolor (data_status == 0);
  figure9 (  0.0, -120.0);
  statecolor (data_status == 1);
  figure8 ( 40.0, -120.0);

  figure15(data_skip);
}

void figure1 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 16), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 16), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y + 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x - 16), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x + 16), (GLfloat)(y + 16), (GLfloat)0.1);
  glEnd();
}  

void figure2 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 16), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  0), (GLfloat)(y - 16.0/3.0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  0), (GLfloat)(y + 0.0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 16), (GLfloat)(y + 16), (GLfloat)0.2);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y + 16), (GLfloat)0.2);
  glVertex3f((GLfloat)(x +  0), (GLfloat)(y -  0), (GLfloat)0.2);
  glVertex3f((GLfloat)(x -  0), (GLfloat)(y - 16.0/3.0), (GLfloat)0.2);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y +  0), (GLfloat)0.1);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y +  0), (GLfloat)0.1);
  glEnd();
}  

void figure3 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 16), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 16), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 16), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 16), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 16), (GLfloat)(y - 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y - 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 16), (GLfloat)(y - 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 8), (GLfloat)(y + 12), (GLfloat)0.1);
  glVertex3f((GLfloat)(x - 16), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x - 8), (GLfloat)(y - 12), (GLfloat)0.1);
  glVertex3f((GLfloat)(x + 16), (GLfloat)(y + 16), (GLfloat)0.1);
  glEnd();
}  

void figure4 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x -  8), (GLfloat)(y +  4), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 16), (GLfloat)(y +  0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  8), (GLfloat)(y -  4), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x -  8), (GLfloat)(y -  2), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  8), (GLfloat)(y -  2), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  8), (GLfloat)(y +  2), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  8), (GLfloat)(y +  2), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x +  8), (GLfloat)(y -  4), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 16), (GLfloat)(y -  0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  8), (GLfloat)(y +  4), (GLfloat)0.0);
  glEnd();
}  

void figure5 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x -  4), (GLfloat)(y +  8), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  4), (GLfloat)(y +  8), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  0), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y +  8), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y -  8), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y -  8), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y +  8), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x -  4), (GLfloat)(y -  8), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  0), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  4), (GLfloat)(y -  8), (GLfloat)0.0);
  glEnd();
}  

void figure6 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x -  4), (GLfloat)(y +  6), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 16), (GLfloat)(y +  0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  4), (GLfloat)(y -  6), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x -  4), (GLfloat)(y -  3), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y -  1), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y +  1), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  4), (GLfloat)(y +  3), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y -  2), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 16), (GLfloat)(y -  0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y +  2), (GLfloat)0.0);
  glEnd();
}  

void figure7 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 14), (GLfloat)(y +  0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 14), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 14), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
}  

void figure8 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 14), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 14), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 14), (GLfloat)(y -  0), (GLfloat)0.0);
  glEnd();
}  

void figure9 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y - 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y - 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y + 12), (GLfloat)0.0);
  glEnd();
}  

void figure10 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 8), (GLfloat)(y +  0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
}  

void figure11 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 8), (GLfloat)(y -  0), (GLfloat)0.0);
  glEnd();
}  

void figure12 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 3), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 3), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 3), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 3), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
}  

void figure13 (double x, double y) {
  figure10(x -  5, y);
  figure12(x + 15, y);
}

void figure14 (double x, double y) {
  figure12(x - 15, y);
  figure11(x +  5, y);
}

void figure15 (int state) {

  int i;
  GLfloat color[4] = {0.0, 0.0, 0.0, 1.0};

  color[0] = (GLfloat)1.0;  color[1] = (GLfloat)1.0;  color[2] = (GLfloat)1.0;
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, color);

  for (i = 0; i < 10; i++) {
    if (state == i) {
      color[0] = (GLfloat)0.0;  color[1] = (GLfloat)0.0;  color[2] = (GLfloat)0.0;
      glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, color);
    }
    figure12 ((double)(12 * i - 54), -160.0);
  }
}

void figure16 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  8), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  8), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x +  8), (GLfloat)(y + 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x -  8), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y + 16), (GLfloat)0.1);
  glEnd();
}  

void figure17 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  0), (GLfloat)(y - 16.0/3.0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  0), (GLfloat)(y + 0.0), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  8), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y + 16), (GLfloat)0.2);
  glVertex3f((GLfloat)(x +  8), (GLfloat)(y + 16), (GLfloat)0.2);
  glVertex3f((GLfloat)(x +  0), (GLfloat)(y -  0), (GLfloat)0.2);
  glVertex3f((GLfloat)(x -  0), (GLfloat)(y - 16.0/3.0), (GLfloat)0.2);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y +  0), (GLfloat)0.1);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y +  0), (GLfloat)0.1);
  glEnd();
}  

void figure18 (double x, double y) {
  figure16(x -  5, y);
  figure5 (x + 12, y);
}

void figure19 (double x, double y) {
  figure17(x -  5, y);
  figure5 (x + 12, y);
}

void figure20 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  8), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y - 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  8), (GLfloat)(y - 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y - 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x +  4), (GLfloat)(y + 12), (GLfloat)0.1);
  glVertex3f((GLfloat)(x - 12), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x -  4), (GLfloat)(y - 12), (GLfloat)0.1);
  glVertex3f((GLfloat)(x + 12), (GLfloat)(y + 16), (GLfloat)0.1);
  glEnd();
}  

void figure21 (double x, double y) {
  figure20(x -  5, y);
  figure5 (x + 12, y);
}

void figure22 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y + 12), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y +  2), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y +  2), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y -  2), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y -  2), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y - 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y - 12), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 10), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 10), (GLfloat)(y - 16), (GLfloat)0.0);
  glEnd();
}

void figure23 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x - 10), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  6), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y + 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x +  6), (GLfloat)(y + 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x - 10), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y - 16), (GLfloat)0.1);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y + 16), (GLfloat)0.1);
  glEnd();
}

void figure24 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y - 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y - 12), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x +  6), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  6), (GLfloat)(y + 12), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x +  6), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  6), (GLfloat)(y - 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  6), (GLfloat)(y - 12), (GLfloat)0.0);
  glEnd();
}

void figure25 (double x, double y) {
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x -  2), (GLfloat)(y - 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x +  2), (GLfloat)(y - 16), (GLfloat)0.0);
  glEnd();
  glBegin(GL_POLYGON);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 10), (GLfloat)(y + 16), (GLfloat)0.0);
  glVertex3f((GLfloat)(x - 10), (GLfloat)(y + 12), (GLfloat)0.0);
  glVertex3f((GLfloat)(x + 10), (GLfloat)(y + 12), (GLfloat)0.0);
  glEnd();
}

void figure26 (double x, double y) {
    figure22 (x - 29, y);
    figure23 (x -  7, y);
    figure24 (x + 11, y);
    figure25 (x + 29, y);
}

void mainMouse (int botton, int state, int x0, int y0) {

    if (botton == 1 && state == 0) {
	fprintf(stdout, "eye(x, y, z) = (%.2f, %.2f, %.2f)\n", 
	       (float)eye[0], (float)eye[1], (float)eye[2]);
	fprintf(stdout, "roll(x, y, z) = (%d, %d, %d)\n", 
		xroll % 360, yroll % 360, zroll % 360);
	fprintf(stdout, "offset(x, y, z) = (%.2f, %.2f, %.2f)\n", 
		xoffset, yoffset, zoffset);
    } else if (botton == 0 && sub_option == 0) {
	sub_option = 1;
    }
	   
    if (botton == 2 && state == 0) {
	if (nomenu) {
	    CreateSubWindow ();
	    nomenu = 0;
	} else {
	    glutDestroyWindow(SubWindow);
	    nomenu = 1;
	}
    }
}

