#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <malloc.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <dirent.h>

extern Display *disp;
extern Colormap cm;
extern int posflag, sub_posy, sub_posx, cdirflag;

char dirs[128];

void getwindowinformation (unsigned int *height, unsigned int *width) {

    Window r; 
    int x, y;
    unsigned int bo, de;

    XGetGeometry (disp, RootWindow(disp, 0), &r, &x, &y, width, height, &bo, &de);
}

void sortdir (char *mp, int max) {

    int i, j;
    char *sortbuf;

    sortbuf = malloc(128);

    for (i = 0; i < (max - 1); i++) 
	for (j = 0; j < (max - 1); j++) 
	    if (strcmp(mp + j * 128, mp + (j + 1) * 128) > 0) {
		strcpy (sortbuf, mp + j * 128);
		strcpy (mp + j * 128, mp + (j + 1) * 128);
		strcpy (mp + (j + 1) * 128, sortbuf);
	    }
    free (sortbuf);
}

char *getdir(char *arg, int *max) {

    struct dirent *dp;
    struct stat fs;
    DIR	*dirp;
    char *direntbuf, *filemap;
    int  i, mm;

    dirp = opendir(arg);
    for (dp = readdir(dirp), mm = 0; dp != NULL; dp = readdir(dirp)) 
	if (!(*(dp->d_name) == '.' && *(dp->d_name + 1) != '.')) mm++;

    filemap = malloc (128 * mm);
    dirp = opendir(arg);
    for (dp = readdir(dirp), i = 0; dp != NULL; dp = readdir(dirp)) 
	if (!(*(dp->d_name) == '.' && *(dp->d_name + 1) != '.'))
	    strcpy((filemap + i++ * 128), dp->d_name);
    closedir (dirp);

    direntbuf = malloc(1024);
    for (i = 0; i < mm; i++) {
	sprintf (direntbuf, "%s%s", arg, (filemap + i * 128));
	stat (direntbuf, &fs);
	if ((fs.st_mode & 0x8000) == 0) 
	    strcat ((filemap + i * 128), "/");
    }
    free (direntbuf);
    sortdir (filemap, mm);
    *max = mm;
    return filemap;
}

unsigned long MyColor(Display *d, char *color_name) {

Colormap        cmap;
XColor          c0, c1;

cmap = DefaultColormap(d, 0);
XAllocNamedColor (d, cmap, color_name, &c1, &c0);

return(c1.pixel);

}

void makewindow (Display *d, Window w, GC gc, char *title, char *mp, int max, int s, int x) {

    int 	i, j, head, length;
    char buffer[128];

    sprintf (buffer, "Select %s.", title);
    i = strlen(buffer);
    XDrawString (d, w, gc, 112 - (i * 7) / 2, 21, buffer, i);
    XDrawLine(d, w, gc,  14,  32, 210,  32);
    XDrawLine(d, w, gc, 210, 226, 210,  32);
    XDrawLine(d, w, gc, 210, 226,  14, 226);
    XDrawLine(d, w, gc,  14,  32,  14, 226);
    XDrawLine(d, w, gc, 196,  32, 196, 226);

    XSetForeground (d, gc, MyColor(d, "white"));
    XFillRectangle (d, w, gc, 20, 33, 172, 193);
    for (j = s; j < ((max + s) < 12 ? max : 12 + s); j++) {
	i = strlen(mp + j * 128);
	if (j == (x + s)) {
	    XSetForeground (d, gc, MyColor(d, "black"));
	    XFillRectangle (d, w, gc, 20, 34 + (j - s) * 16,170, 16);
	    XSetForeground (d, gc, MyColor(d, "white"));
	    XDrawString (d, w, gc, 21, 47 + (j - s) * 16, mp + j * 128, i > 24 ? 24 : i );
	} else {
	    XSetForeground (d, gc, MyColor(d, "black"));
	    XDrawString (d, w, gc, 21, 47 + (j - s) * 16, mp + j * 128, i > 24 ? 24 : i );
	}	    
    }

    head = s * 191 / (max < 12 ? 12 : max) + 34;
    length = 12 * 191 / (max < 12 ? 12 : max);
    XSetForeground (d, gc, MyColor(d, "white"));
    XFillRectangle (d, w, gc, 199, 34 ,10, 191);
    XSetForeground (d, gc, MyColor(d, "Dimgray"));
    XFillRectangle (d, w, gc, 199, head ,10, length);
    XSetForeground (d, gc, MyColor(d, "black"));

    XFlush(d);
}

char *selecttask (Display *d, Window w, GC gc, char *title) {
    
    static char	ret[128];
    char *filemap, sourcedir[128], localtmp[256];
    int  x, x0, s, max, bottonflag, head, select, flag;
    XEvent      e;

    XSelectInput (d, w, ButtonPressMask | ButtonReleaseMask | PointerMotionMask | ExposureMask); 
    if (cdirflag) {
	strcpy (sourcedir, dirs);
    } else {
	strcpy (sourcedir, "./");
    }

    filemap = getdir (sourcedir, &max);
    while (1) {
	s = head = 0; x = select = x0 = -1; bottonflag = flag = 0;
	makewindow (d, w, gc, title, filemap, max, head, select);
	while (1) {
	    XNextEvent(d, &e);
	    switch (e.type) {
	      case ButtonPress:
		if (e.xbutton.x > 14 && e.xbutton.x < 196 && e.xbutton.y > 32 && e.xbutton.y < 226) {
		    x = (e.xbutton.y - 32) / 16;
		    if (x >= (head + max)) x = -1;
		    if (x == x0 && x != -1) {
			strcpy(ret, (filemap + (x + head) * 128));
			flag = 1;
			break;
		    } else {
			x0 = select = x;
			makewindow (d, w, gc, title, filemap, max, head, select);
			break;
		    }
		} else if (e.xbutton.x > 195 && e.xbutton.x < 210 && e.xbutton.y > 32 && e.xbutton.y < 226) {
		    bottonflag = 1;
		} else {
		    break;
		}
	      case MotionNotify:
		if (bottonflag) {
		    if (max < 13) break;
		    if (e.type != MotionNotify)
			head = (max * (e.xbutton.y - 32) / 191 - 6);
		    else 
			head = (max * (e.xmotion.y - 32) / 191 - 6);
		    if (head < 0) head = 0;
		    if (head > max - 12) head = max - 12;
		    if (s == head) break;
		    x -= (head - s);
		    x0 = select = x;
		    s = head;
		    makewindow (d, w, gc, title, filemap, max, head, select);
		    break;
		}
		break;
	      case ButtonRelease:
		bottonflag = 0;
		break;
	      case Expose:
		makewindow (d, w, gc, title, filemap, max, head, select);
		break;
	    }
	    if (flag) break;
	}
	if (*(ret + strlen(ret) - 1) != '/') {
	    sprintf(localtmp, "%s%s", sourcedir, ret);
	    strcpy (ret, localtmp);
	    break;
	}
	free (filemap);
	sprintf (localtmp, "%s%s", sourcedir, ret);
	strcpy (sourcedir, localtmp);
	filemap = getdir (sourcedir, &max);
    }
    strcpy (dirs, sourcedir);
    return ret;
}

char *XSelectFile (Display *d, char *xt, char *title) {
    
    Window      w;
    GC          gc;
    XSizeHints  h;
    Font	f;
    char       *ret;

    if (posflag) {
	w = XCreateSimpleWindow (d, RootWindow (d, 0), sub_posx, sub_posy, 224, 242, 2, 1, MyColor(d, "white"));
	h.flags = USPosition;
	XSetWMNormalHints (d, w, &h);
    } else {
	w = XCreateSimpleWindow (d, RootWindow (d, 0), 100, 100, 224, 242, 2, 1, MyColor(d, "white"));
    }	
    XStoreName(d, w, xt);
    gc = XCreateGC (d, w, 0, 0);
    f = XLoadFont(d, "-misc-*-*-*-*--14-*-*-*-*-*-*-1");
    XSetFont(d, gc, f);
    XSetBackground (d, gc, MyColor(d, "white"));
    XSetForeground (d, gc, MyColor(d, "black"));
    XMapWindow (d, w);
    ret = selecttask (d, w, gc, title);
    XDestroyWindow (d, w);
    return ret;
}

float *getColorRGB(char *cname)
{
  XColor ce, cs;
  static float rgb[3]; 

  XAllocNamedColor(disp, cm, cname, &ce, &cs); 

  rgb[0] = (float)ce.red/(float)0xffff;
  rgb[1] = (float)ce.green/(float)0xffff;
  rgb[2] = (float)ce.blue/(float)0xffff;

  return(rgb);
}
